%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% (CHEM-E7225) ADVANCED PROCESS CONTROL D
%   #03 - Optimal control of dynamic systems
%
%   Complete this starting code (and function Linearize.m) to control 
%   the Three-Tank System for the control tasks described in Exercise 03.
%
%   Find and replace each '???' with the correct code. 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
close all; clear; clc

addpath('~/path/to/casadi')
import casadi.*

%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% DYNAMICAL SYSTEM DEFINITIONS
% Control horizon and discretization
K  = ???;          % Control horizon
dT = ???;          % Discretisation period
t  = ???;          % Time nodes (t_0,...,t_K-1)

% Dynamics, initial and reference conditions
Nx = ???;          % Number of state vars
Nu = ???;          % Number of controls

% Model parameters
S_T = ???;  S_V = ???;  % and so on...

px = [ ??? ];

% Initial state
x0 = [ ??? ]; 

% AFFINE MODEL: Linearisation of the dynamics 
xp = ???;
up = ???;

ThreeTank_Lin = Linearize(@ThreeTank, dT, xp, up, px);
[c,A,B] = ThreeTank_Lin{:};

%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% OPTIMAL CONTROL PROBLEM DEFINITIONS

%   TODO: Copy and paste your solution from E03A_main.m
%       | directly into this section, but change any use of
%       | the integrator to F(.) = c + A x_k + B u_k.

???   


%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plotting all the simulation results
%
%  NOTE: You don't need to complete this part, but feel free to 
%        customize the plots according to your style. 

TTank_NL = load('ThreeTank_OCP.mat');   % Loads the solution from E03A_main.m

lw = 1.0; fs = 14;
figure(1), clf; 
for j = 1:2
  subplot(2,3,j+(j==2)), hold on
    stairs(t(1:end-1), TTank_NL.u_sol(j,:), 'k-', 'linewidth', lw, 'color', [0.75 0.75 0.75 0.33])
    stairs(t(1:end-1), u_sol(j,:), 'k-', 'linewidth', lw)
    ylabel("$u_"+j+"(t)$ [ml/s]",'Interpreter','Latex'); ylim([0,140])
    set(gca,'TickLabelInterpreter','Latex','FontSize',fs)
    box off
end

for j = 1:3
  subplot(2,3,3+j), hold on
    stairs(t, x_ref(j,:)', 'r-', 'linewidth', lw); 
    stairs(t, TTank_NL.x_sol(j,:)', 'k-', 'linewidth', lw, 'color', [0.75 0.75 0.75 0.33]); 
    stairs(t, x_sol(j,:)', 'k-', 'linewidth', lw); 
    ylabel("$x_"+j+"(t)$ [cm]",'Interpreter','Latex'); ylim([0,60])
    xlabel('Time  - $t$ [s]','Interpreter','Latex')
    set(gca,'TickLabelInterpreter','Latex','FontSize',fs)
    box off

  if j == 3; legend(["Reference", "Nonlinear $F(\cdot)$", "Linear $F(\cdot)$"], 'Interpreter', 'Latex')
end